import * as _crossmint_wallets_sdk from '@crossmint/wallets-sdk';
import { GetOrCreateWalletProps } from '../types/wallet.cjs';

declare function useWallet(): ({
    status: "not-loaded" | "in-progress";
    wallet?: undefined;
    type?: undefined;
    error?: undefined;
} & {
    getOrCreateWallet: (args: GetOrCreateWalletProps) => Promise<{
        startedCreation: boolean;
        reason?: string;
    }>;
    clearWallet: () => void;
}) | ({
    status: "loading-error";
    wallet?: undefined;
    type?: undefined;
    error: string;
} & {
    getOrCreateWallet: (args: GetOrCreateWalletProps) => Promise<{
        startedCreation: boolean;
        reason?: string;
    }>;
    clearWallet: () => void;
}) | ({
    status: "loaded";
    wallet: _crossmint_wallets_sdk.EVMSmartWallet;
    type: "evm-smart-wallet";
    error?: undefined;
} & {
    getOrCreateWallet: (args: GetOrCreateWalletProps) => Promise<{
        startedCreation: boolean;
        reason?: string;
    }>;
    clearWallet: () => void;
}) | ({
    status: "loaded";
    wallet: _crossmint_wallets_sdk.SolanaSmartWallet;
    type: "solana-smart-wallet";
    error?: undefined;
} & {
    getOrCreateWallet: (args: GetOrCreateWalletProps) => Promise<{
        startedCreation: boolean;
        reason?: string;
    }>;
    clearWallet: () => void;
});

export { useWallet };
